#ifndef _graph_runtime_ins_h_
#define _graph_runtime_ins_h_

// (C) by Thalion Graphic Solutions e.K. 2001
//
// Permissions to copy, modify and redistribute
// granted, according to the conditions defined
// in the Gnu Public License (GPL).
// Please read the file gpl.txt provided with this
// distribution.

//
// The interpreter instruction set, variant 2:
// a stack machine with accumulator.
// This should allow for better code optimization
// by the compiler.
//

typedef enum {
    LDC   = 0, // Constant from DS to acc
    LDI   = 1, // Immediate to acc
    LDL   = 2, // Local to acc
    LDC_PUSH   = 3, // Constant from DS to acc
    LDI_PUSH   = 4, // Immediate to acc
    LDL_PUSH   = 5, // Local to acc
    LDS   = 6, // Stack to acc
    STL   = 7, // Acc to local
    PUSH  = 8, // Acc to stack
    PUSHC = 9, // Constant from DS to stack
    PUSHI = 10, // Immediate to stack
    PUSHL = 11, // Local to stack
    POP = 12,
    DUP = 13,
    EXCH = 14,
    CALL = 15,
    RET = 16,

    J = 17,
    JT = 18,
    JF = 19,

    F2I = 20,
    I2F = 21,

    FADD = 22,
    FSUB = 23,
    FMUL = 24,
    FDIV = 25,
    FPOW = 26,
    FNEG = 27,

    IADD = 28,
    ISUB = 29,
    IMUL = 30,
    IDIV = 31,
    IMOD = 32,
    IPOW = 33,
    INEG = 34,

    EQ = 35,
    NE = 36,

    IGT = 37,
    IGE = 38,
    ILT = 39,
    ILE = 40,

    FGT = 41,
    FGE = 42,
    FLT = 43,
    FLE = 44,

    AND = 45,
    OR  = 46,
    XOR = 47,
    NOT = 48,
    SIN = 49,
    COS = 50,
    TAN = 51,
    ASIN = 52,
    ACOS = 53,
    ATAN = 54,

    EOC = 63   // End Of Code mark.   
} ins_t;


#endif
