#ifndef _graph_runtime_ins_h_
#define _graph_runtime_ins_h_

// (C) by Thalion Graphic Solutions e.K. 2001
//
// Permissions to copy, modify and redistribute
// granted, according to the conditions defined
// in the Gnu Public License (GPL).
// Please read the file gpl.txt provided with this
// distribution.

//
// The interpreter instruction set, variant 1:
// a plain stack machine.
//

typedef enum {
    PUSHC = 0,
    PUSHI = 1,
    PUSHL = 2,
    STL = 3,
    POP = 4,
    DUP = 5,
    EXCH = 6,
    CALL = 7,
    RET = 8,

    J = 9,
    JT = 10,
    JF = 11,

    F2I = 12,
    I2F = 13,

    FADD = 14,
    FSUB = 15,
    FMUL = 16,
    FDIV = 17,
    FPOW = 18,
    FNEG = 19,

    IADD = 20,
    ISUB = 21,
    IMUL = 22,
    IDIV = 23,
    IMOD = 24,
    IPOW = 25,
    INEG = 26,

    EQ = 27,
    NE = 28,

    IGT = 29,
    IGE = 30,
    ILT = 31,
    ILE = 32,

    FGT = 33,
    FGE = 34,
    FLT = 35,
    FLE = 36,

    AND = 37,
    OR  = 38,
    XOR = 39,
    NOT = 40,

    SIN = 41,
    COS = 42,
    TAN = 43,
    ASIN = 44,
    ACOS = 45,
    ATAN = 46,
	    
    EOC = 63   // End Of Code mark.   
} ins_t;


#endif
