package graph3d.peer;

// (C) by Thalion Graphic Solutions e.K. 2001
//
// Permissions to copy, modify and redistribute
// granted, according to the conditions defined
// in the Gnu Public License (GPL).
// Please read the file gpl.txt provided with this
// distribution.

import java.awt.*;

/**
 * The GraphicsConfigTemplate peer.
 */
public class GraphicsConfigTemplate {

   /**
    * Tries to find a match for viewport config.
    * The method checks the passed configuration, and returns true,
    * if it is a suitable one.
    * @param gc a configuration to check
    * @return true, if it's usable, else false
    */
   public static boolean checkVpConfiguration(final GraphicsConfiguration gc)
   {
      return Context.getInstance().checkVpConfiguration(gc);
   }

   /**
    * Tries to find a match for offscreen config.
    * The method checks the passed configuration, and returns true,
    * if it is a suitable one.
    * @param gc a configuration to check
    * @return true, if it's usable, else false
    */
   public static boolean checkOffsConfiguration(final GraphicsConfiguration gc)
   {
      return Context.getInstance().checkOffsConfiguration(gc);
   }
   
}

