package graph3d.peer;

// (C) by Thalion Graphic Solutions e.K. 2001
//
// Permissions to copy, modify and redistribute
// granted, according to the conditions defined
// in the Gnu Public License (GPL).
// Please read the file gpl.txt provided with this
// distribution.

import graph3d.Function;

/**
 * Instances of this class represent jgraph internally
 * interpreted functions, i.e. functions that are defined
 * in jgraph's bytecode.
 */
public class InterpretedFunction
   implements Function {
   
   private long handle_;
   
   /**
    * Create a new proxy to native instance given by
    * handle.
    * @param handle the native instance handle
    */
   InterpretedFunction(long handle)
   {
      handle_ = handle;
   }
   
   /**
    * This method returns a human readable representation
    * for this function, including the name and type signature,
    * as used by the graph stack machine.
    * @return the descriptive name of this function
    */
   public String toString()
   {
      return Context.getInstance().getFunctionName(handle_) +
             Context.getInstance().getFunctionType(handle_);
   }
   
   /**
    * Dispose the native instance of this function.
    */
   public void finalize()
   {
      Context.getInstance().disposeFunction(handle_);
   }
   
}
