package ui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Copied and modified from the Java tutorial (file of same name).
 * Modified: the dialog takes and returns indices instead of strings.
 */
public class InputDialog extends JDialog {

    private static InputDialog dialog_;

    static {
        Frame frame = JOptionPane.getFrameForComponent(App.getInstance());
        dialog_     = new InputDialog(frame,
                                      ResourceManager.getDialogString("define"),
                                      ResourceManager.getDialogString("enter-code"));    
    }

    private JTextArea  textarea_;
    
    public static void showDialog()
    {
       dialog_.setVisible(true);
    }
    
    public static void updateDialog(String text)
    {
       dialog_.setText(text);
       dialog_.repaint();
    }
    
    public void setText(String text) {
        textarea_.setText(text);
    }

    private InputDialog(Frame frame, String title, String labelText) {
        super(frame, title, false);

        //buttons
        JButton cb = new JButton();
        ResourceManager.setIconForButton("none",cb);
        cb.setToolTipText(ResourceManager.getToolTip("close"));
        final JButton db = new JButton();
        ResourceManager.setIconForButton("define",db);
        db.setToolTipText(ResourceManager.getToolTip("define-selected"));
        final JButton dab = new JButton();
        ResourceManager.setIconForButton("define-all",dab);
        dab.setToolTipText(ResourceManager.getToolTip("define-all"));
        cb.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                InputDialog.dialog_.setVisible(false);
            }
        });
        db.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                App.getInstance().newCB(textarea_.getSelectedText());
            }
        });
        dab.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                App.getInstance().newCB(textarea_.getText());
            }
        });	
        getRootPane().setDefaultButton(dab);

        //main part of the dialog
        textarea_ = new JTextArea();
	textarea_.setEditable(true);
        JScrollPane textScroller = new JScrollPane(textarea_);
        textScroller.setPreferredSize(new Dimension(300, 300));
        //XXX: Must do the following, too, or else the scroller thinks
        //XXX: it's taller than it is:
        textScroller.setMinimumSize(new Dimension(300, 300));
        textScroller.setAlignmentX(LEFT_ALIGNMENT);

        //Create a container so that we can add a title around
        //the scroll pane.  Can't add a title directly to the 
        //scroll pane because its background would be white.
        //Lay out the label and scroll pane from top to button.
        JPanel textPane = new JPanel();
        textPane.setLayout(new BoxLayout(textPane, BoxLayout.Y_AXIS));
        JLabel label = new JLabel(labelText);
        label.setLabelFor(textarea_);
        textPane.add(label);
        textPane.add(Box.createRigidArea(new Dimension(0,5)));
        textPane.add(textScroller);
        textPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

        //Lay out the buttons from left to right.
        JPanel buttonPane = new JPanel();
        buttonPane.add(cb);
        buttonPane.add(db);
        buttonPane.add(dab);

        //Put everything together, using the content pane's BorderLayout.
        Container contentPane = getContentPane();
        contentPane.add(textPane, BorderLayout.CENTER);
        contentPane.add(buttonPane, BorderLayout.SOUTH);

        pack();
    }

}
