package ui.res;

import java.awt.MediaTracker;

import java.io.IOException;
import java.net.URL;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;

public class Images extends ResourceBundle {

   private static Hashtable hash_;

   private static String res_; 
   private static String psep_;

   private final static String[] suffices_ = {
      "-default.gif",
      "-pressed.gif",
      "-rollover.gif"
   };

   private static ImageIcon loadIcon(String name)
   {
      name = res_ + psep_ + "images" + psep_ + name;
      try {
         URL url = new URL(name);
         ImageIcon icon = new ImageIcon(url);
         if ( icon.getImageLoadStatus() != MediaTracker.COMPLETE ) {
            System.err.println("Failed to load '" + name + "'.");
         }
         return icon;
      }
      catch ( IOException exception ) {
         System.err.println("Failed to load '" + name + "'.");
         return null;
      }
   }

   /**
    * Load one set of icons (used as one symbol on a
    * control - different named images mark up different states).
    * @param name the icon set name
    * @return an array of image icons, representing the set
    */
   private static ImageIcon[] loadIconSet(String name)
   {
      ImageIcon[] set = new ImageIcon[3];
      for( int i=0; i<3; i++ ) {
         set[i] = loadIcon(name + suffices_[i]);
      }
      return set;
   }

   /**
    * Preloading all icons.
    */
   static {
      res_  = System.getProperty("jgraph.res");
      psep_ = System.getProperty("file.separator");
      hash_ = new Hashtable();
      hash_.put("axes",loadIconSet("axes"));      
      hash_.put("contours",loadIconSet("contours"));
      hash_.put("define",loadIconSet("define"));
      hash_.put("define-all",loadIconSet("define-all"));
      hash_.put("light0",loadIconSet("light0"));
      hash_.put("light1",loadIconSet("light1"));
      hash_.put("lighting",loadIconSet("lighting"));
      hash_.put("lines",loadIconSet("lines"));
      hash_.put("loop",loadIconSet("loop"));
      hash_.put("new",loadIconSet("new"));
      hash_.put("none",loadIconSet("none"));
      hash_.put("open",loadIconSet("open"));
      hash_.put("plot",loadIconSet("plot"));
      hash_.put("points",loadIconSet("points"));
      hash_.put("preferences",loadIconSet("preferences"));
      hash_.put("printer",loadIconSet("printer"));
      hash_.put("reset",loadIconSet("reset"));
      hash_.put("smooth",loadIconSet("smooth"));
      hash_.put("swing",loadIconSet("swing"));
      hash_.put("logo",loadIcon("logo.jpg"));
   }


   public Object handleGetObject(String key)
   {
      return hash_.get(key);
   }

   public Enumeration getKeys()
   {
      return hash_.keys();
   }

}
