// (C) by Thalion Graphic Solutions e.K. 2001
//
// Permissions to copy, modify and redistribute
// granted, according to the conditions defined
// in the Gnu Public License (GPL).
// Please read the file gpl.txt provided with this
// distribution.

#include <graph/codegen.h>
#include <stdlib.h>
#include <string.h>

graph::CodeGen::CodeGen(graph::Runtime& env):
   env_(env),
   dp_(0),
   cf_(NULL),
   cf_name_(NULL),
   cf_signature_(NULL),
   cf_argc_(0),
   cf_dp_(0)
{
   // empty.
}

unsigned graph::CodeGen::beginFunction(const char *name,
                                       const char *signature,
		  		       unsigned argc)
{
   cf_ = NULL;
   cf_cs_.clear();
   if ( cf_name_ ) {
      delete[] cf_name_;
   }
   cf_name_ = new char[strlen(name) + 1];
   strcpy(cf_name_,name);
   if ( cf_signature_ ) {
      delete[] cf_signature_;
   }
   cf_signature_ = new char[strlen(signature) + 1];
   strcpy(cf_signature_,signature);
   cf_argc_ = argc;
   cf_dp_ = dp_;
   return dp_ ++;
}

unsigned graph::CodeGen::addIns(graph::Runtime::ins_t op)
{
   Runtime::Ins ins(op);
   cf_cs_.push_back(ins);
   return cf_cs_.size() - 1;
}

unsigned graph::CodeGen::addIns(graph::Runtime::ins_t op,unsigned par)
{
   Runtime::Ins ins(op,par);
   cf_cs_.push_back(ins);
   return cf_cs_.size() - 1;
}

void graph::CodeGen::endFunction()
{
   Runtime::Value v;
   Runtime::Ins ins(Runtime::EOC);
   cf_cs_.push_back(ins);
   cf_ = v.f_ = new Function(cf_name_,cf_signature_,&cf_cs_.front(),cf_cs_.size(),cf_argc_);
   if ( ! env_.setData(cf_dp_,*v.f_) ) {
      delete cf_;
      cf_ = NULL;
      throw datasize_exceeded();
   }
}

void graph::CodeGen::reset()
{
   cf_    = NULL;
   cf_dp_ = 0;
   dp_    = 0;
   cf_cs_.clear();
}
