//
// Consistency.
//

c_a(x) := x

// Should look all the same,
// with and without inlining.
c_b(x,y) := x * y
c_c(x,y) := c_a(x) * c_a(y)

// Enforces automatic cast to int and back
c_d(x:int) := x

// Should plot in steps.
c_e(x,y) := c_d(x) * c_d(y)

//
// Function type arguments.
//
fta_a(x) := x
fta_b(f:function(float),x) := f(x)
fta_c(x) := fta_b(fta_a,x)

//
// Function return types
//
ftr_d(f:function(float)) :function(float) := f
ftr_e(x) := (ftr_d(fta_a))(x)

//
// Constants.
//
cs_even(n:int):bool := (n % 2 = 0)
cs_a(x:int,y:int) :=
   if cs_even(x) and cs_even(y) then 1 else -1
cs_b(x,y) := cs_a(x,y)

//
// Conditionals
//
nested_if(x) :=
   if ( x > -1 ) then
      if ( x < 1 ) then
         _sin x
      else
         _cos x
   else
      x ** 2

nested_if_plot(x,y) := nested_if(x) + nested_if(y)

//
// Recursion
//
fib(n:int):int :=
   if ( n < 2 ) then 1 else fib(n-1) + fib(n-2)

fib_plot(x,y) := fib(x) + fib(y)

 
